window.Gleam.initSearch([{"doc":"ref","title":"ref","content":"# ref\n\n[![Package Version](https://img.shields.io/hexpm/v/ref)](https://hex.pm/packages/ref)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/ref/)\n\n```sh\ngleam add ref\n```\n```gleam\nimport ref\n\npub fn main() {\n  let myref = cell(0)\n  io.debug(get(myref))\n  // -&gt; 0\n\n  set(myref, get(myref) + 1)\n  set(myref, get(myref) + 1)\n  set(myref, get(myref) + 1)\n\n  io.debug(get(myref))\n  // -&gt; 3\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/ref&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n","url":"index.html"},{"doc":"ref","title":"RefCell","content":"pub opaque type RefCell(a)\n The reference cell type for holding mutable data\n\nSynonyms:\nref.RefCell\nref RefCell","url":"ref.html#RefCell"},{"doc":"ref","title":"cell","content":"pub fn cell(contents: a) -&gt; RefCell(a)\n Public constructor for creating a new RefCell. The initial value is passed, and a RefCell containing that value is returned.\nSynonyms:\nref.cell\nref cell","url":"ref.html#cell"},{"doc":"ref","title":"get","content":"pub fn get(cell: RefCell(a)) -&gt; a\n Used for extracting the held data in a RefCell.\n Once the value has been extracted with this function, any mutations on the Cell will not affect the data already extracted.\nSynonyms:\nref.get\nref get","url":"ref.html#get"},{"doc":"ref","title":"main","content":"pub fn main() -&gt; Int\n\nSynonyms:\nref.main\nref main","url":"ref.html#main"},{"doc":"ref","title":"map","content":"pub fn map(subj: RefCell(a), f: fn(a) -&gt; b) -&gt; RefCell(b)\n Map the result of a function taking a Cell&#39;s contents into a new RefCell. No mutation takes place\nSynonyms:\nref.map\nref map","url":"ref.html#map"},{"doc":"ref","title":"set","content":"pub fn set(cell: RefCell(a), contents: a) -&gt; Nil\n Used for setting the inner value of a RefCell\nSynonyms:\nref.set\nref set","url":"ref.html#set"},{"doc":"ref","title":"set_fun","content":"pub fn set_fun(cell: RefCell(a), f: fn(a) -&gt; a) -&gt; RefCell(a)\n Weird restrictive binding operation for a RefCell, as the operation sets the cell to the value that the passed function evaluates to\nSynonyms:\nref.set_fun\nref set_fun","url":"ref.html#set_fun"},{"doc":"ref","title":"ref","content":" A ref cell library for the gleam erlang target. The implementation uses actors for keeping track of the values\n of references, so a new process is spawned for each mutable reference you create. These mutable references should\n only be used if mutability is absolutely required. Immutability should always be preferred, and this implementation loses\n the performance benefits that mutability generally provide.","url":"ref.html"}]);